/* This file is part of flowz.
   Copyright (C) 2006 Sergey Poznyakoff

   Flowz is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Flowz is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with flowz; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <exit.h>
#include <exitfail.h>
#include <getdelim.h>
#include <getline.h>
#include <gettext.h>
#include <hash.h>
#include <verify.h>
#include <xalloc.h>
#include <error.h>
#include <inttypes.h>
#include <intprops.h>
#include <inttostr.h>
#include <obstack.h>

#define EXIT_SUXESS   0 
#define EXIT_FAILURE  1
#define EXIT_MILDFAIL 2

#define UINTMAX_STRSIZE_BOUND INT_BUFSIZE_BOUND (uintmax_t)

extern char *program_name;
extern FILE *outfile;
extern FILE *infile;
extern char *input;
extern size_t lineno;
extern int verbose;
extern char *header_str;
extern off_t max_memory_usage;

typedef int (*compress_fn)(char **toks, size_t ntoks);

int level_1(char **toks, size_t ntoks);
int level_2(char **toks, size_t ntoks);
int level_3(char **toks, size_t ntoks);

int update(char *key, time_t time_start, time_t time_end, uintmax_t octets);
char *make_key(unsigned char *map, int mapsize, char **toks);
void dump_table(FILE *fp, const char *header);
int parse_timerange(const char *str, time_t *ptime_start, time_t *ptime_end);
void throw_error(void);
void table_init(void);
void table_stat(FILE *fp);
size_t table_n_entries(void);


